/*Copyright (c) 2022, Nexperia
*All rights reserved.
*
*Redistribution and use in source and binary forms, with or without modification, 
*are permitted provided that the following conditions are met:
*
*1. Redistributions of source code must retain the above copyright notice, 
*this list of conditions and the following disclaimer.
*
*2. Redistributions in binary form must reproduce the above copyright 
*notice, this list of conditions and the following disclaimer in the 
*documentation and/or other materials provided with the distribution.
*
*3. Neither the name of the copyright holder nor the names of its contributors 
*may be used to endorse or promote products derived from this software without 
*specific prior written permission.
*
*THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY 
*EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES 
*OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT 
*SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, 
*INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED 
*TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR 
*BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
*CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN 
*ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * --/COPYRIGHT--*/

//Evaluation board codecode that uses the Serial Prompt of Arduino IDE to program NCA9555 EVB RevA
//Uses Arduino UNO, go to Tools -> Board to change board type.
//Go to Tools -> Serial Port and select correct Port that Arduino is connected to. This information can be found through Device Manager.
//Reset Arduino after uloading code
//  Date   :  Nov 01, 2022
//  Version:  1.00
//  File   :  NCA95xx_main.ino

#include <Wire.h>
String stringone;
String stringtwo;


const int deviceaddress = 0x20;
const int inputP0 = 0x00;
const int inputP1 = 0x01;
const int outputP0 = 0x02;
const int outputP1 = 0x03;
const int INVP0 = 0x04;
const int INVP1 = 0x05;
const int ConfigP0 = 0x06;
const int ConfigP1 = 0x07;
int RegRead = 0;

int ar[30];
int X = 0;
int Y = 0;
int comm;

void setup() {
  Wire.begin();                // join i2c bus (address optional for master)
  Serial.begin(2000000);          // start serial communication at 9600bps


  // initialize digital pin LED_BUILTIN as an output.
  pinMode(LED_BUILTIN, OUTPUT);

  pinMode(A0, INPUT);
  //pinMode(A0, INPUT_PULLUP);
  pinMode(A1, INPUT);
  //pinMode(A1, INPUT_PULLUP);
  pinMode(A2, INPUT);
  //pinMode(A2, INPUT_PULLUP);
  
  while (Serial.available() == 0) ;  // Wait here until input buffer has a character
  {
    stringone = Serial.readString();        //
    if (stringone == "READY") {
      Serial.println("SHOWTIME");

    } else {
      Serial.println("Didn't sync");

    }

  }
}

void loop() {

  //write8(deviceaddress, ConfigP0, 0xF0);
  //write8(deviceaddress, outputP0, 0xF9);
  //RegRead = read8(deviceaddress, inputP0);
  //Serial.println(RegRead, HEX);  // print the reading

  while (Serial.available() == 0) {
    if (X > 0) {
      //Serial.println(ar[0]);
      //Serial.println(ar[1]);

      if (ar[0] == 99) {//standard write"99",slave,register,data
        write8(ar[1], ar[2], ar[3]);
      }

      if (ar[0] == 88) {//standard read"88",slave,register
        RegRead = read8(ar[1], ar[2]);
        Serial.println(RegRead);
      }
      if (ar[0] == 77) {//button write"77", slave, register, bit, value
        int ormask = 0;
        int andmask = 0;
        int WValue = 0;
        RegRead = read8(ar[1], ar[2]);
        ormask = 1 << ar[3];
        //Serial.println(ar[4]);
        if (ar[4] == 1) {
          WValue = RegRead | ormask;
        } else {
          WValue = RegRead & ~ormask;
        }
        write8(ar[1], ar[2], WValue);

      }
      if (ar[0] == 66) {//Write All"66",numbreg,slave,register,data,register2,data2,etc

        for (int i = 0; i < ar[1]; i++) {
          write8(ar[2], ar[i * 2 + 3], ar[i * 2 + 4]);
        }
      }

      if (ar[0] == 55) {//Read All"55",numbreg,slave,register,register2,register3...
        for (int i = 0; i < ar[1]; i++) {
          RegRead = read8(ar[2], ar[3 + i]);

          if (i == (ar[1] - 1)) {
            Serial.println(RegRead);
          } else {
            Serial.print(RegRead);
            Serial.print(",");
          }
        }

      }




    }
    X = 0;//turn off flag that array was built to start over for next cycle
    // Wait here until input buffer has a character
    //Serial.println(comm);
  } // Wait here until input buffer has a character

  ar[X] = Serial.parseInt();
  Y = ar[X];
  X = X + 1;






  //delay(300);                  // wait a bit since people have to read the output :)
}


void write8(int SRegister, int Address, int Data) {
  Wire.beginTransmission(SRegister);
  Wire.write(Address);
  Wire.write(Data);
  Wire.endTransmission();
}

int read8(int SRegister, int Address) {
  int ReadD = 0;
  Wire.beginTransmission(SRegister);
  Wire.write(Address);
  Wire.endTransmission();
  Wire.requestFrom(SRegister, 1);
  Wire.endTransmission();
  ReadD = Wire.read();
  return ReadD;
}
